unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, DB, Grids, DBGrids, ADODB, StdCtrls, ComCtrls, shellapi,
  ActnList, dxExEdtr, dxCntner, dxTL, dxDBCtrl, dxDBGrid, inifiles;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    cNumero: TLabel;
    TAB: TPageControl;
    tabConectar: TTabSheet;
    tabSQL: TTabSheet;
    Splitter2: TSplitter;
    Panel4: TPanel;
    bEjecutarSQL: TButton;
    GroupBox1: TGroupBox;
    opCModificacion: TRadioButton;
    opCSeleccion: TRadioButton;
    Panel5: TPanel;
    Splitter3: TSplitter;
    Panel6: TPanel;
    DBGrid2: TDBGrid;
    txtSQL: TMemo;
    tabInsercionMasiva: TTabSheet;
    GroupBox2: TGroupBox;
    txtUsuario: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    txtContrasena: TEdit;
    txtBD: TEdit;
    Label5: TLabel;
    bConectar: TButton;
    Label9: TLabel;
    txtStringConexion: TEdit;
    GroupBox3: TGroupBox;
    opMySQL: TRadioButton;
    opOracle: TRadioButton;
    txtServidor: TEdit;
    lServidor: TLabel;
    txtPuerto: TEdit;
    lPuerto: TLabel;
    txtProveedor: TEdit;
    Label10: TLabel;
    GroupBox4: TGroupBox;
    bInsercionMasiva: TButton;
    txtLetra: TEdit;
    txtNumero: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Memo1: TMemo;
    Label7: TLabel;
    Label8: TLabel;
    LWEB: TLabel;
    ActionList1: TActionList;
    actEjecutarSQL: TAction;
    actConectarBD: TAction;
    Label11: TLabel;
    SaveDialog1: TSaveDialog;
    procedure bInsercionMasivaClick(Sender: TObject);
    procedure opMySQLClick(Sender: TObject);
    procedure opOracleClick(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
    procedure actEjecutarSQLExecute(Sender: TObject);
    procedure actConectarBDExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses UnidadDataModule;

{$R *.dfm}

procedure TForm1.bInsercionMasivaClick(Sender: TObject);
var
  i : integer;
begin
  try
    DataModule1.ADOTable1.Active := True;
  except
    MessageDlg('Recuerde que debe haber ejecutado el SQL para ' +
        'la insercin de la tabla "TABLA_PRUEBA", y tambin debe ' +
        'haber realizado la conexin a la BD.', mtError, [mbok], 0);
  end;
  for i := 0 to strtoint(txtNumero.Text) do
  begin
    DataModule1.DataSource1.DataSet.Insert;
    DataModule1.DataSource1.DataSet.FieldByName('CODIGO').Value :=
        txtLetra.Text + IntToStr(i);
    DataModule1.DataSource1.DataSet.FieldByName('NOMBRE').Value := 'Campo nombre ' +
        DateToStr(Date) + TimeToStr(Time) + '  -  ' + IntToStr(i);
    DataModule1.DataSource1.DataSet.FieldByName('NOTA').Value :=
      'Registro aadido automticamente: ' +
        DateToStr(Date) + TimeToStr(Time);
    DataModule1.DataSource1.DataSet.FieldByName('FECHA').value := date;
    try
      DataModule1.DataSource1.DataSet.Post;
    Except
    end;
  end;
  DataModule1.ADOQuery1.Close;
  DataModule1.ADOQuery1.SQL.Clear;
  DataModule1.ADOQuery1.SQL.Add('select count(codigo) as NUMERO from TABLA_PRUEBA');
  DataModule1.ADOQuery1.Open;
  cNumero.Caption := 'N de registros: ' +
      FloatToStr(DataModule1.ADOQuery1.FieldByName('NUMERO').Value);
  cNumero.Refresh;
  DataModule1.DataSource1.DataSet.EnableControls;
end;

procedure TForm1.opMySQLClick(Sender: TObject);
begin
  txtPuerto.Visible := true;
  lPuerto.Visible := true;
  txtServidor.Visible := true;
  lServidor.Visible := true;
  txtProveedor.Text := 'MSDASQL.1'; 
end;

procedure TForm1.opOracleClick(Sender: TObject);
begin
  txtPuerto.Visible := false;
  lPuerto.Visible := false;
  txtServidor.Visible := false;
  lServidor.Visible := false;
  txtProveedor.Text := 'OraOLEDB.Oracle.1';  
end;

procedure TForm1.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TForm1.actEjecutarSQLExecute(Sender: TObject);
begin
  if DataModule1.ADOConnection1.Connected then
  begin
    DataModule1.ADOQuery2.Close;
    DataModule1.ADOQuery2.SQL.Clear;
    DataModule1.ADOQuery2.SQL.AddStrings(txtSQL.Lines);
    if opCSeleccion.Checked then
    begin
      try
        DataModule1.ADOQuery2.Open;
        MessageDlg('Consulta de seleccin ejecutada correctamente.',
            mtInformation, [mbok], 0);
      except
        raise
      end;
    end
    else
    begin
      try
        DataModule1.ADOQuery2.ExecSQL;
        MessageDlg('Consulta de modificacin/insercin ejecutada correctamente.',
            mtInformation, [mbok], 0);
      except
        raise;
      end;
    end;
  end
  else
  begin
    MessageDlg('Primero debe conectarse con un usuario que tenga ' +
        'los suficientes privilegios como para ejecutar la sentencia SQL.',
        mtWarning, [mbOK], 0);
    tabConectar.Show;
    txtUsuario.SetFocus;
  end;
end;

procedure TForm1.actConectarBDExecute(Sender: TObject);
begin
  DataModule1.ADOTable1.Close;
  DataModule1.ADOConnection1.Close;
  DataModule1.ADOConnection1.Provider := txtProveedor.text;
  if opOracle.Checked then
    DataModule1.ADOConnection1.ConnectionString :=
        'Provider=OraOLEDB.Oracle.1;' +
        'Persist Security Info=True;' +
        'User ID=' + txtUsuario.Text + ';' +
        'Password=' + txtContrasena.Text + ';' +
        'Data Source=' + txtBD.Text;
  if opMySQL.Checked then
    DataModule1.ADOConnection1.ConnectionString :=
        'Provider=MSDASQL.1;' +
        'Persist Security Info=True;' +
        'Extended Properties="DRIVER={MySQL ODBC 3.51 Driver};DESC=;' +
        'DATABASE=' + txtBD.Text + ';' +
        'SERVER=' + txtServidor.text + ';' +
        'UID=' + txtUsuario.Text + ';' +
        'PASSWORD=' + txtContrasena.Text + ';' +
        'PORT=' + txtpuerto.text + ';' +
        'OPTION=131072;STMT=;"';
  txtStringConexion.Text := DataModule1.ADOConnection1.ConnectionString;
  try
    DataModule1.ADOConnection1.Connected := true;
    MessageDlg('Se ha conectado correctamente a la BD: ' +
        txtBD.Text + '.', mtInformation, [mbok], 0);
  except
    raise;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    WriteBool('Acceso a BD', 'MySQL', opMySQL.Checked);
    WriteBool('Acceso a BD', 'Oracle', opOracle.Checked);
    Writestring('Acceso a BD', 'Usuario', txtUsuario.Text);
    WriteString('Acceso a BD', 'Contrasea', txtContrasena.Text);
    WriteString('Acceso a BD', 'Base datos', txtBD.Text);
    WriteString('Acceso a BD', 'Proveedor', txtProveedor.Text);
    WriteString('Acceso a BD', 'Servidor', txtServidor.Text);
    WriteString('Acceso a BD', 'Puerto', txtPuerto.Text);    
  finally
    free;
  end;
  txtSQL.Lines.SaveToFile(extractfilepath(ParamStr(0)) + 'sql.txt');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  with tinifile.create (changefileext(paramstr(0),'.ini')) do
  try
    opMySQL.Checked := ReadBool('Acceso a BD', 'MySQL', false);
    opOracle.Checked := readBool('Acceso a BD', 'Oracle', true);
    txtusuario.text := readstring('Acceso a BD', 'Usuario', '');
    txtContrasena.Text := readString('Acceso a BD', 'Contrasea', '');
    txtBD.Text := readString('Acceso a BD', 'Base datos', '');    
    txtProveedor.Text := readString('Acceso a BD', 'Proveedor', 'OraOLEDB.Oracle.1');
    txtServidor.Text := readString('Acceso a BD', 'Servidor', 'localhost');
    txtPuerto.Text := readString('Acceso a BD', 'Puerto', '3306');
  finally
    free;
  end;
  if FileExists(extractfilepath(ParamStr(0)) + 'sql.txt') then
    txtSQL.Lines.LoadFromFile(extractfilepath(ParamStr(0)) + 'sql.txt');
end;

end.
